/* global module */
// Uses window for get messages

var IframeEventHandler = function (window, buffer, marker) {
  'use strict'
// ---------------------------------------------------------------------------

  var eventName = 'message'

  var handler = function (event) {
    var msg = event.data

    if (msg.target === 'push') {
      buffer.pushFromIframe(msg.sessionID, msg.values, msg.sizes)
    } if (msg.target === 'pushRawBytes') {
      buffer.pushRawBytesFromIframe(msg.sessionID, msg.bytes)
    } else if (msg.target === 'send') {
      buffer.send()
    }
  }

  this.start = function () {
    window.addEventListener(eventName, handler)
  }

  this.stop = function () {
    window.removeEventListener(eventName, handler)
  }

// ---------------------------------------------------------------------------
}

module.exports = IframeEventHandler
